// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/AdvisorySpeed.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__ADVISORY_SPEED__STRUCT_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__ADVISORY_SPEED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'type'
#include "etsi_its_spatem_ts_msgs/msg/detail/advisory_speed_type__struct.hpp"
// Member 'speed'
#include "etsi_its_spatem_ts_msgs/msg/detail/speed_advice__struct.hpp"
// Member 'confidence'
#include "etsi_its_spatem_ts_msgs/msg/detail/speed_confidence_dsrc__struct.hpp"
// Member 'distance'
#include "etsi_its_spatem_ts_msgs/msg/detail/zone_length__struct.hpp"
// Member 'cls'
#include "etsi_its_spatem_ts_msgs/msg/detail/restriction_class_id__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__AdvisorySpeed __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__AdvisorySpeed __declspec(deprecated)
#endif

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AdvisorySpeed_
{
  using Type = AdvisorySpeed_<ContainerAllocator>;

  explicit AdvisorySpeed_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : type(_init),
    speed(_init),
    confidence(_init),
    distance(_init),
    cls(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->speed_is_present = false;
      this->confidence_is_present = false;
      this->distance_is_present = false;
      this->cls_is_present = false;
    }
  }

  explicit AdvisorySpeed_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : type(_alloc, _init),
    speed(_alloc, _init),
    confidence(_alloc, _init),
    distance(_alloc, _init),
    cls(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->speed_is_present = false;
      this->confidence_is_present = false;
      this->distance_is_present = false;
      this->cls_is_present = false;
    }
  }

  // field types and members
  using _type_type =
    etsi_its_spatem_ts_msgs::msg::AdvisorySpeedType_<ContainerAllocator>;
  _type_type type;
  using _speed_type =
    etsi_its_spatem_ts_msgs::msg::SpeedAdvice_<ContainerAllocator>;
  _speed_type speed;
  using _speed_is_present_type =
    bool;
  _speed_is_present_type speed_is_present;
  using _confidence_type =
    etsi_its_spatem_ts_msgs::msg::SpeedConfidenceDSRC_<ContainerAllocator>;
  _confidence_type confidence;
  using _confidence_is_present_type =
    bool;
  _confidence_is_present_type confidence_is_present;
  using _distance_type =
    etsi_its_spatem_ts_msgs::msg::ZoneLength_<ContainerAllocator>;
  _distance_type distance;
  using _distance_is_present_type =
    bool;
  _distance_is_present_type distance_is_present;
  using _cls_type =
    etsi_its_spatem_ts_msgs::msg::RestrictionClassID_<ContainerAllocator>;
  _cls_type cls;
  using _cls_is_present_type =
    bool;
  _cls_is_present_type cls_is_present;

  // setters for named parameter idiom
  Type & set__type(
    const etsi_its_spatem_ts_msgs::msg::AdvisorySpeedType_<ContainerAllocator> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__speed(
    const etsi_its_spatem_ts_msgs::msg::SpeedAdvice_<ContainerAllocator> & _arg)
  {
    this->speed = _arg;
    return *this;
  }
  Type & set__speed_is_present(
    const bool & _arg)
  {
    this->speed_is_present = _arg;
    return *this;
  }
  Type & set__confidence(
    const etsi_its_spatem_ts_msgs::msg::SpeedConfidenceDSRC_<ContainerAllocator> & _arg)
  {
    this->confidence = _arg;
    return *this;
  }
  Type & set__confidence_is_present(
    const bool & _arg)
  {
    this->confidence_is_present = _arg;
    return *this;
  }
  Type & set__distance(
    const etsi_its_spatem_ts_msgs::msg::ZoneLength_<ContainerAllocator> & _arg)
  {
    this->distance = _arg;
    return *this;
  }
  Type & set__distance_is_present(
    const bool & _arg)
  {
    this->distance_is_present = _arg;
    return *this;
  }
  Type & set__cls(
    const etsi_its_spatem_ts_msgs::msg::RestrictionClassID_<ContainerAllocator> & _arg)
  {
    this->cls = _arg;
    return *this;
  }
  Type & set__cls_is_present(
    const bool & _arg)
  {
    this->cls_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__AdvisorySpeed
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__AdvisorySpeed
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AdvisorySpeed_ & other) const
  {
    if (this->type != other.type) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    if (this->speed_is_present != other.speed_is_present) {
      return false;
    }
    if (this->confidence != other.confidence) {
      return false;
    }
    if (this->confidence_is_present != other.confidence_is_present) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    if (this->distance_is_present != other.distance_is_present) {
      return false;
    }
    if (this->cls != other.cls) {
      return false;
    }
    if (this->cls_is_present != other.cls_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const AdvisorySpeed_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AdvisorySpeed_

// alias to use template instance with default allocator
using AdvisorySpeed =
  etsi_its_spatem_ts_msgs::msg::AdvisorySpeed_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__ADVISORY_SPEED__STRUCT_HPP_
