// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_spatem_ts_msgs:msg/SPAT.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPAT__STRUCT_H_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPAT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'time_stamp'
#include "etsi_its_spatem_ts_msgs/msg/detail/minute_of_the_year__struct.h"
// Member 'name'
#include "etsi_its_spatem_ts_msgs/msg/detail/descriptive_name__struct.h"
// Member 'intersections'
#include "etsi_its_spatem_ts_msgs/msg/detail/intersection_state_list__struct.h"

/// Struct defined in msg/SPAT in the package etsi_its_spatem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_spatem_ts_msgs__msg__SPAT
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   spatem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// SPAT ::= SEQUENCE {
  ///   timeStamp     MinuteOfTheYear OPTIONAL,
  ///   name          DescriptiveName OPTIONAL,
  ///   intersections IntersectionStateList,
  ///   regional      SEQUENCE (SIZE(1..4)) OF
  ///                 RegionalExtension {{Reg-SPAT}} OPTIONAL,
  /// ------------------------------------------------------------------------------
  etsi_its_spatem_ts_msgs__msg__MinuteOfTheYear time_stamp;
  bool time_stamp_is_present;
  etsi_its_spatem_ts_msgs__msg__DescriptiveName name;
  bool name_is_present;
  etsi_its_spatem_ts_msgs__msg__IntersectionStateList intersections;
} etsi_its_spatem_ts_msgs__msg__SPAT;

// Struct for a sequence of etsi_its_spatem_ts_msgs__msg__SPAT.
typedef struct etsi_its_spatem_ts_msgs__msg__SPAT__Sequence
{
  etsi_its_spatem_ts_msgs__msg__SPAT * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_spatem_ts_msgs__msg__SPAT__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPAT__STRUCT_H_
