// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/TimeChangeDetails.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__TIME_CHANGE_DETAILS__TRAITS_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__TIME_CHANGE_DETAILS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_spatem_ts_msgs/msg/detail/time_change_details__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'start_time'
// Member 'min_end_time'
// Member 'max_end_time'
// Member 'likely_time'
// Member 'next_time'
#include "etsi_its_spatem_ts_msgs/msg/detail/time_mark__traits.hpp"
// Member 'confidence'
#include "etsi_its_spatem_ts_msgs/msg/detail/time_interval_confidence__traits.hpp"

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const TimeChangeDetails & msg,
  std::ostream & out)
{
  out << "{";
  // member: start_time
  {
    out << "start_time: ";
    to_flow_style_yaml(msg.start_time, out);
    out << ", ";
  }

  // member: start_time_is_present
  {
    out << "start_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.start_time_is_present, out);
    out << ", ";
  }

  // member: min_end_time
  {
    out << "min_end_time: ";
    to_flow_style_yaml(msg.min_end_time, out);
    out << ", ";
  }

  // member: max_end_time
  {
    out << "max_end_time: ";
    to_flow_style_yaml(msg.max_end_time, out);
    out << ", ";
  }

  // member: max_end_time_is_present
  {
    out << "max_end_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.max_end_time_is_present, out);
    out << ", ";
  }

  // member: likely_time
  {
    out << "likely_time: ";
    to_flow_style_yaml(msg.likely_time, out);
    out << ", ";
  }

  // member: likely_time_is_present
  {
    out << "likely_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.likely_time_is_present, out);
    out << ", ";
  }

  // member: confidence
  {
    out << "confidence: ";
    to_flow_style_yaml(msg.confidence, out);
    out << ", ";
  }

  // member: confidence_is_present
  {
    out << "confidence_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.confidence_is_present, out);
    out << ", ";
  }

  // member: next_time
  {
    out << "next_time: ";
    to_flow_style_yaml(msg.next_time, out);
    out << ", ";
  }

  // member: next_time_is_present
  {
    out << "next_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.next_time_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TimeChangeDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: start_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_time:\n";
    to_block_style_yaml(msg.start_time, out, indentation + 2);
  }

  // member: start_time_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.start_time_is_present, out);
    out << "\n";
  }

  // member: min_end_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_end_time:\n";
    to_block_style_yaml(msg.min_end_time, out, indentation + 2);
  }

  // member: max_end_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_end_time:\n";
    to_block_style_yaml(msg.max_end_time, out, indentation + 2);
  }

  // member: max_end_time_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_end_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.max_end_time_is_present, out);
    out << "\n";
  }

  // member: likely_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "likely_time:\n";
    to_block_style_yaml(msg.likely_time, out, indentation + 2);
  }

  // member: likely_time_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "likely_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.likely_time_is_present, out);
    out << "\n";
  }

  // member: confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confidence:\n";
    to_block_style_yaml(msg.confidence, out, indentation + 2);
  }

  // member: confidence_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confidence_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.confidence_is_present, out);
    out << "\n";
  }

  // member: next_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "next_time:\n";
    to_block_style_yaml(msg.next_time, out, indentation + 2);
  }

  // member: next_time_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "next_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.next_time_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TimeChangeDetails & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_spatem_ts_msgs::msg::TimeChangeDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_spatem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_spatem_ts_msgs::msg::TimeChangeDetails & msg)
{
  return etsi_its_spatem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails>()
{
  return "etsi_its_spatem_ts_msgs::msg::TimeChangeDetails";
}

template<>
inline const char * name<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails>()
{
  return "etsi_its_spatem_ts_msgs/msg/TimeChangeDetails";
}

template<>
struct has_fixed_size<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails>
  : std::integral_constant<bool, has_fixed_size<etsi_its_spatem_ts_msgs::msg::TimeIntervalConfidence>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::TimeMark>::value> {};

template<>
struct has_bounded_size<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails>
  : std::integral_constant<bool, has_bounded_size<etsi_its_spatem_ts_msgs::msg::TimeIntervalConfidence>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::TimeMark>::value> {};

template<>
struct is_message<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__TIME_CHANGE_DETAILS__TRAITS_HPP_
