// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_spatem_ts_msgs:msg/MovementPhaseState.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_PHASE_STATE__STRUCT_H_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_PHASE_STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__UNAVAILABLE = 0
};

/// Constant 'DARK'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__DARK = 1
};

/// Constant 'STOP_THEN_PROCEED'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__STOP_THEN_PROCEED = 2
};

/// Constant 'STOP_AND_REMAIN'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__STOP_AND_REMAIN = 3
};

/// Constant 'PRE_MOVEMENT'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__PRE_MOVEMENT = 4
};

/// Constant 'PERMISSIVE_MOVEMENT_ALLOWED'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__PERMISSIVE_MOVEMENT_ALLOWED = 5
};

/// Constant 'PROTECTED_MOVEMENT_ALLOWED'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__PROTECTED_MOVEMENT_ALLOWED = 6
};

/// Constant 'PERMISSIVE_CLEARANCE'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__PERMISSIVE_CLEARANCE = 7
};

/// Constant 'PROTECTED_CLEARANCE'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__PROTECTED_CLEARANCE = 8
};

/// Constant 'CAUTION_CONFLICTING_TRAFFIC'.
enum
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState__CAUTION_CONFLICTING_TRAFFIC = 9
};

/// Struct defined in msg/MovementPhaseState in the package etsi_its_spatem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_spatem_ts_msgs__msg__MovementPhaseState
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   spatem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// MovementPhaseState ::= ENUMERATED {
  ///   unavailable (0),
  ///   dark (1),
  ///   stop-Then-Proceed (2),
  ///   stop-And-Remain (3),
  ///   pre-Movement (4),
  ///   permissive-Movement-Allowed (5),
  ///   protected-Movement-Allowed (6),
  ///   permissive-clearance (7),
  ///   protected-clearance (8),
  ///   caution-Conflicting-Traffic (9)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_spatem_ts_msgs__msg__MovementPhaseState;

// Struct for a sequence of etsi_its_spatem_ts_msgs__msg__MovementPhaseState.
typedef struct etsi_its_spatem_ts_msgs__msg__MovementPhaseState__Sequence
{
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_spatem_ts_msgs__msg__MovementPhaseState__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_PHASE_STATE__STRUCT_H_
