// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_spatem_ts_msgs:msg/MovementState.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_STATE__STRUCT_H_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'movement_name'
#include "etsi_its_spatem_ts_msgs/msg/detail/descriptive_name__struct.h"
// Member 'signal_group'
#include "etsi_its_spatem_ts_msgs/msg/detail/signal_group_id__struct.h"
// Member 'state_time_speed'
#include "etsi_its_spatem_ts_msgs/msg/detail/movement_event_list__struct.h"
// Member 'maneuver_assist_list'
#include "etsi_its_spatem_ts_msgs/msg/detail/maneuver_assist_list__struct.h"

/// Struct defined in msg/MovementState in the package etsi_its_spatem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_spatem_ts_msgs__msg__MovementState
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   spatem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// MovementState ::= SEQUENCE {
  ///   movementName       DescriptiveName OPTIONAL,
  ///   signalGroup        SignalGroupID,
  ///   state-time-speed   MovementEventList,
  ///   maneuverAssistList ManeuverAssistList OPTIONAL,
  ///   regional           SEQUENCE (SIZE(1..4)) OF
  ///                      RegionalExtension {{Reg-MovementState}} OPTIONAL,
  /// ------------------------------------------------------------------------------
  etsi_its_spatem_ts_msgs__msg__DescriptiveName movement_name;
  bool movement_name_is_present;
  etsi_its_spatem_ts_msgs__msg__SignalGroupID signal_group;
  etsi_its_spatem_ts_msgs__msg__MovementEventList state_time_speed;
  etsi_its_spatem_ts_msgs__msg__ManeuverAssistList maneuver_assist_list;
  bool maneuver_assist_list_is_present;
} etsi_its_spatem_ts_msgs__msg__MovementState;

// Struct for a sequence of etsi_its_spatem_ts_msgs__msg__MovementState.
typedef struct etsi_its_spatem_ts_msgs__msg__MovementState__Sequence
{
  etsi_its_spatem_ts_msgs__msg__MovementState * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_spatem_ts_msgs__msg__MovementState__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_STATE__STRUCT_H_
