// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/SPAT.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPAT__STRUCT_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPAT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'time_stamp'
#include "etsi_its_spatem_ts_msgs/msg/detail/minute_of_the_year__struct.hpp"
// Member 'name'
#include "etsi_its_spatem_ts_msgs/msg/detail/descriptive_name__struct.hpp"
// Member 'intersections'
#include "etsi_its_spatem_ts_msgs/msg/detail/intersection_state_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__SPAT __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__SPAT __declspec(deprecated)
#endif

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SPAT_
{
  using Type = SPAT_<ContainerAllocator>;

  explicit SPAT_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : time_stamp(_init),
    name(_init),
    intersections(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_stamp_is_present = false;
      this->name_is_present = false;
    }
  }

  explicit SPAT_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : time_stamp(_alloc, _init),
    name(_alloc, _init),
    intersections(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_stamp_is_present = false;
      this->name_is_present = false;
    }
  }

  // field types and members
  using _time_stamp_type =
    etsi_its_spatem_ts_msgs::msg::MinuteOfTheYear_<ContainerAllocator>;
  _time_stamp_type time_stamp;
  using _time_stamp_is_present_type =
    bool;
  _time_stamp_is_present_type time_stamp_is_present;
  using _name_type =
    etsi_its_spatem_ts_msgs::msg::DescriptiveName_<ContainerAllocator>;
  _name_type name;
  using _name_is_present_type =
    bool;
  _name_is_present_type name_is_present;
  using _intersections_type =
    etsi_its_spatem_ts_msgs::msg::IntersectionStateList_<ContainerAllocator>;
  _intersections_type intersections;

  // setters for named parameter idiom
  Type & set__time_stamp(
    const etsi_its_spatem_ts_msgs::msg::MinuteOfTheYear_<ContainerAllocator> & _arg)
  {
    this->time_stamp = _arg;
    return *this;
  }
  Type & set__time_stamp_is_present(
    const bool & _arg)
  {
    this->time_stamp_is_present = _arg;
    return *this;
  }
  Type & set__name(
    const etsi_its_spatem_ts_msgs::msg::DescriptiveName_<ContainerAllocator> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__name_is_present(
    const bool & _arg)
  {
    this->name_is_present = _arg;
    return *this;
  }
  Type & set__intersections(
    const etsi_its_spatem_ts_msgs::msg::IntersectionStateList_<ContainerAllocator> & _arg)
  {
    this->intersections = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__SPAT
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__SPAT
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::SPAT_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SPAT_ & other) const
  {
    if (this->time_stamp != other.time_stamp) {
      return false;
    }
    if (this->time_stamp_is_present != other.time_stamp_is_present) {
      return false;
    }
    if (this->name != other.name) {
      return false;
    }
    if (this->name_is_present != other.name_is_present) {
      return false;
    }
    if (this->intersections != other.intersections) {
      return false;
    }
    return true;
  }
  bool operator!=(const SPAT_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SPAT_

// alias to use template instance with default allocator
using SPAT =
  etsi_its_spatem_ts_msgs::msg::SPAT_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPAT__STRUCT_HPP_
